#include <iostream>
#include <cmath>
using namespace std;
int main()
{
    long long n;
    int i,j;
    long m;
    cin>>n>>m;
    long b[m+1];
    long long a[n+1];
    int q;
    for(q=1;q<=m;q++)
    {
        cin>>b[q];
        a[q] = q;
    }
    long long c;
    cin>>c;
    for(q=m+1;q<=n;q++)
        a[q] = q;
    for(i=0;i<=n-m;i++)
        for(j=1;j<=m;j++)
            a[i+b[j]]=a[i+j];
    long long x=0;
    for(i=1;i<=n;i++)
        x+= pow(c,i) * a[i];
    x = x%998244353;
    cout<<x;
}